Prime Path(广搜)

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

题意:给两个四位数n,m,转换n的每位数每次的数为素数,并且是每次都是没出现的输出最少步数

思路:用广搜为基础,加上素数打表,枚举每个数的情况

#include<stdio.h>
#include<string.h>
#include<iostream>
#include<queue>
#include<math.h>
#define min 0x3f3f3f3f

using namespace std;

int arr[10005];
int flag[10005];
int n,m;

void prim()//素数打表
{
    int i,j;
    arr[0]=arr[1]=1;
    for(i=2;i<=10000;i++)
    {
        if(!arr[i])
        {
            for(j=i*2;j<=10000;j+=i)
            arr[j]=1;
        }
    }
}

int bfs(int first,int last)
{
    queue <int>q;
    int v,i,j,temp,vtemp,count[10005],N[4];
    memset(flag,0,sizeof(flag));
    memset(count,0,sizeof(count));
    q.push(first);
    flag[first]=1;
    while(!q.empty())
    {
        v=q.front();
        q.pop();
        N[0]=v/1000;
        N[1]=v%1000/100;
        N[2]=v%100/10;
        N[3]=v%10;
        for(j=0;j<4;j++)
        {
            temp=N[j];
            for(i=0;i<10;i++)//枚举每种情况
                if(i!=temp)
                {
                    N[j]=i;
                    vtemp=N[0]*1000+N[1]*100+N[2]*10+N[3];
                    if(!flag[vtemp] && !arr[vtemp] &&vtemp>1000)
                    {
                        flag[vtemp]=1;//标记
                        count[vtemp]=count[v]+1;//步数加一
                        q.push(vtemp);
                    }
                    if(vtemp==last) return count[vtemp];//当变化完之后的值相等,返回其步数
                }
            N[j]=temp;//将原本的赋值回去
        }
        if(v==last) return count[v];//若两个数相等,返回其步数
    }
    return -1;
}

int main()
{
    int t,k;
    cin>>t;
    prim();
    while(t--)
    {
        cin>>n>>m;
        k=bfs(n,m);
        if(k!=-1)
        cout<<k<<endl;
        else
        cout<<"Impossible"<<endl;
    }
    return 0;
}



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值